> module Angabe3 where

1. Vervollstaendigen Sie gemaess Angabentext!
2. Vervollst�ndigen Sie auch die vorgegebenen Kommentaranf�nge!
3. Loeschen Sie keine Deklarationen aus diesem Rahmenprogramm, auch nicht die Modulanweisug!
4. Achten Sie darauf, dass `Gruppe' Leserechte fuer Ihre Abgabedatei hat!

> type Nat1      = Int
> type Zeile     = [Int]

Matrizen konzeptuell als Listen von Zeilen dargestellt:

> newtype Matrix = M [Zeile]

> fehlerwert = M [] :: Matrix

> data Matrixtyp = Mat (Nat1,Nat1) | KeineMatrix deriving (Eq,Show)


Aufgabe A.1

> instance Show Matrix where
>   show m = matrixToString m "("

Solution:
    * if the parameter matrix is an empty matrix, return "()"
    * if the current row of the matrix is not empty, but the rest of the matrix is, then add the current row and close the string with ")"
    * otherwise, add the current row to the result and call the function recursively with the rest of the matrix

> matrixToString :: Matrix -> String -> String
> matrixToString matrix res
>   | isEmpty matrix = "()"
>   | length m /= 0 && null ms = res ++ show m ++ ")"
>   | otherwise = matrixToString restMatrix (res ++ show m ++ " ")
>   where
>       (M (m:ms)) = matrix
>       restMatrix = (M ms)

Aufgabe A.2

Solution:
    * if the parameter is an empty matrix, then return KeineMatrix
    * check if the parameter is an NM matrix by obtaining the length of the first row and comparing it with each consequitive one. If there is a mismatch, then the matrix is not a NM matrix
    * if the parameter is an NM matrix, return the pair (height, width)

> matrixtyp :: Matrix -> Matrixtyp
> matrixtyp m
>   | isEmpty m = KeineMatrix
>   | isCorrectMatrix m 0 == False = KeineMatrix
>   | otherwise = getMatrixType m

> isCorrectMatrix :: Matrix -> Int -> Bool
> isCorrectMatrix matrix n
>   | isEmpty matrix = True
>   | n == 0 && length m == 0 = False
>   | n == 0 && length m /= 0 = isCorrectMatrix matrix (length m)
>   | n == length m = isCorrectMatrix (M ms) n
>   | otherwise = False
>   where
>       (M (m:ms)) = matrix

> getMatrixType :: Matrix -> Matrixtyp
> getMatrixType (M (m:ms)) = (Mat (length (m:ms), length m))

Aufgabe A.3

> instance Eq Matrix where
>   (==) (M m1) (M m2)
>       | m1 Prelude.== [] || m2 Prelude.== [] = error "Gleichheit undefiniert"
>       | matrixtyp (M m1) == KeineMatrix || matrixtyp (M m2) == KeineMatrix = error "Gleichheit undefiniert"
>       | otherwise = (m1 Prelude.== m2)
>   (/=) (M m1) (M m2)
>       | m1 Prelude.== [] || m2 Prelude.== [] = error "Ungleichheit undefiniert"
>       | matrixtyp (M m1) == KeineMatrix || matrixtyp (M m2) == KeineMatrix = error "Ungleichheit undefiniert"
>       | otherwise = (m1 Prelude./= m2)

> isEmpty :: Matrix -> Bool
> isEmpty (M m)
>   | null m = True
>   | otherwise = False

Aufgabe A.4

> instance Num Matrix where
>   (+) m1 m2 = (add m1 m2)
>   (-) m1 m2 = (diff m1 m2)
>   (*) m1 m2 = (mult m1 m2)
>   negate m = negation m
>   abs m = absolute m
>   signum m = sign m
>   fromInteger z = (M [[fromIntegral z]])

> add :: Matrix -> Matrix -> Matrix
> add (M m1) (M m2)
>   | isEmpty (M m1) || isEmpty (M m2) = fehlerwert
>   | matrixtyp (M m1) == KeineMatrix || matrixtyp (M m2) == KeineMatrix = fehlerwert
>   | matrixtyp (M m1) /= matrixtyp (M m2) = fehlerwert
>   | otherwise = M (zipWith (zipWith (+)) m1 m2)

> diff :: Matrix -> Matrix -> Matrix
> diff (M m1) (M m2)
>   | isEmpty (M m1) || isEmpty (M m2) = fehlerwert
>   | matrixtyp (M m1) == KeineMatrix || matrixtyp (M m2) == KeineMatrix = fehlerwert
>   | matrixtyp (M m1) /= matrixtyp (M m2) = fehlerwert
>   | otherwise = M (zipWith (zipWith (-)) m1 m2)

> mult :: Matrix -> Matrix -> Matrix
> mult (M m1) (M m2)
>   | isEmpty (M m1) || isEmpty (M m2) = fehlerwert
>   | matrixtyp (M m1) == KeineMatrix || matrixtyp (M m2) == KeineMatrix = fehlerwert
>   | otherwise = M ([[0]])

> negation :: Matrix -> Matrix
> negation (M m1)
>   | isEmpty (M m1)= fehlerwert
>   | matrixtyp (M m1) == KeineMatrix = fehlerwert
>   | otherwise = M (map (map ((-1)*)) m1)

> absolute :: Matrix -> Matrix
> absolute (M m1)
>   | isEmpty (M m1)= fehlerwert
>   | matrixtyp (M m1) == KeineMatrix = fehlerwert
>   | otherwise = M (map (map (abs)) m1)

> sign :: Matrix -> Matrix
> sign (M m1)
>   | isEmpty (M m1)= error "Vorzeichenfunktion undefiniert"
>   | matrixtyp (M m1) == KeineMatrix = error "Vorzeichenfunktion undefiniert"
>   | otherwise = M ([[0]])
